]> git.wh0rd.org - home.git/blob - .bin/r
r: handle random remotes better
[home.git] / .bin / r
1 #!/bin/bash
2 g() { git "$@"; }
3 err() { printf '%b\n' "$*" 1>&2; exit 1; }
4 vr() { echo "$@"; "$@"; }
5
6 case $1 in
7 ""|-*) ;;
8 l)
9 cmd=list
10 shift
11 ;;
12 s)
13 cmd=sync
14 shift
15 ;;
16 *)
17 cmd=$1
18 shift
19 acmd=$(git config --get "alias.${cmd}" | sed 's: -.*::')
20 ;;
21 esac
22
23 mj_init() {
24 pipe=$(mktemp)
25 rm -f "${pipe}"
26 mkfifo "${pipe}"
27 exec {ctlfd}<>"${pipe}"
28 rm -f "${pipe}"
29 jobs=0
30 jobs_max=${1:-$(getconf _NPROCESSORS_ONLN)}
31 }
32 _mj_child() { echo ${BASHPID} $? >&${ctlfd} ; }
33 mj_child() {
34 (
35 "$@"
36 _mj_child
37 ) &
38 mj_post_child
39 }
40 mj_post_child() {
41 : $(( ++jobs ))
42 if [[ ${jobs} -eq ${jobs_max} ]] ; then
43 read -r -u ${ctlfd} pid ret
44 : $(( --jobs ))
45 fi
46 }
47 mj_finish() {
48 wait
49 }
50
51 repo_root() {
52 local root=${PWD}
53 while [[ ! -d ${root}/.repo && ${root} != "/" ]] ; do
54 root=${root%/*}
55 done
56 echo "${root}"
57 }
58
59 case ${acmd:-${cmd}} in
60 rebase)
61 if [[ $1 == "all" ]] ; then
62 shift
63 if [[ $# -eq 0 ]] ; then
64 eval $(bash-colors --env | sed 's:^:export :')
65 root=$(repo_root)
66 mj_init
67 while read -a line ; do
68 dir=${line[0]}
69 proj=${line[2]}
70 cd "${root}/${dir}"
71 (
72 out=$(env _proj=${proj} r rb all . 2>&1)
73 if [[ -n ${out} ]] ; then
74 while read line ; do
75 if [[ ${line} == "# "* ]] ; then
76 line="${line#[#] }"
77 printf '%s### %s%-40s%s: %s\n' \
78 "${BRACKET}" "${GOOD}" "${line%%:*}" "${NORMAL}" "${line#*:}"
79 else
80 echo "${line}"
81 fi
82 done < <(echo "${out}")
83 fi
84 _mj_child
85 ) &
86 mj_post_child
87 done < <(r l)
88 mj_finish
89 exit 0
90 #exec r forall -p -c 'r rb all .' </dev/null
91 fi
92
93 branches=$(g b | awk '
94 {
95 if ($0 ~ "^[*] *[(]no branch[)]") {
96 next
97 } else if ($1 == "*") {
98 b = $2
99 } else {
100 list = list $1 " "
101 }
102 }
103 END { print list b }')
104 [[ -z ${branches} ]] && exit 0
105
106 [[ -z ${GOOD} ]] && eval $(bash-colors --env)
107 #echo "${GOOD}### ${PWD}${NORMAL}"
108 # Skip if rebase is in progress.
109 if [[ -e .git/rebase-merge/interactive ]] ; then
110 echo -e "# ${_proj}: ${WARN}skipping due to active rebase${NORMAL}"
111 exit 1
112 fi
113 for b in ${branches} ; do
114 #echo " ${HILITE}### $b${NORMAL}"
115 g co -q $b || exit 1
116 if ! r rb -q "$@" ; then
117 g rb-a
118 fi
119 done
120 exit 0
121 fi
122 ;;
123 sb-push)
124 sync_branch="v"
125
126 root=$(repo_root)
127 cd "${root}" || exit 1
128
129 if [[ ! -e .repo/sandbox-url ]] ; then
130 err "Please configure remote url base in ${root}/.repo/sandbox-url"
131 fi
132 remote=$(<.repo/sandbox-url) || exit 1
133
134 echo "pushing projects from ${root}"
135
136 # ssh servers do not like it when you hammer them :)
137 # Received disconnect from 74.125.248.80: 7: Too many concurrent connections
138 # fatal: The remote end hung up unexpectedly
139 mj_init 16
140
141 rlist=$(r list)
142 tcnt=$(echo "${rlist}" | wc -l)
143 cnt=1
144 while read line ; do
145 line=( ${line} )
146 path=${line[0]}
147 export GIT_DIR=${path}/.git
148 proj=${line[2]}
149 printf '### (%*i/%i %3i%%) %s\n' \
150 ${#tcnt} $((cnt++)) ${tcnt} $(( cnt * 100 / tcnt )) ${proj}
151 src="${sync_branch}"
152 g l -1 ${src} >& /dev/null || src=
153 mj_child g push --force ${remote}/${proj} ${src}:refs/sandbox/${USER}/${sync_branch} >/dev/null
154 done < <(r list)
155 mj_finish
156
157 exit 0
158 ;;
159 g-push)
160 # For the times when repo is being stupid, push directly to gerrit myself.
161 if ! branch=$(g symbolic-ref -q HEAD) ; then
162 err "could not figure out active branch"
163 fi
164 branch=${branch#refs/heads/}
165 if ! remote_branch=$(g cfg --get "branch.${branch}.merge") ; then
166 err "could not figure out remote branch"
167 fi
168 if ! remote=$(g cfg --get "branch.${branch}.remote") ; then
169 for remote in cros-internal cros origin ; do
170 g cfg --get "remote.${remote}.url" >/dev/null && break
171 done
172 fi
173 remote_branch=${remote_branch#refs/heads/}
174
175 git_args=()
176 reviewers=""
177 while [[ $# -gt 0 ]] ; do
178 case $1 in
179 --re)
180 reviewers=$2
181 shift
182 ;;
183 -n|--dry-run)
184 git_args+=( $1 )
185 ;;
186 *)
187 err "unknown option: $1"
188 ;;
189 esac
190 shift
191 done
192
193 if [[ -n ${reviewers} ]] ; then
194 reviewers=( ${reviewers//,/ } )
195 git_args+=( "--receive-pack=git receive-pack ${reviewers[*]/#/--reviewer=}" )
196 fi
197
198 vr git push "${git_args[@]}" ${remote} ${branch}:refs/for/${remote_branch} && exit
199 err "could not figure out remote to push to"
200 ;;
201 sync)
202 set -- -j16 "$@"
203 ;;
204 upload)
205 args=()
206 while [[ $# -gt 0 ]] ; do
207 case $1 in
208 --re)
209 if [[ $2 == *"OWNERS" ]] ; then
210 owners=$(awk -F'@' '{list = list "," $1} END {print substr(list, 2)}' "$2")
211 if [[ -z ${owners} ]] ; then
212 err "cannot find OWNERS list"
213 else
214 echo "Auto setting reviewers to: ${owners}"
215 fi
216 args+=( --re "${owners}" )
217 shift 2
218 continue
219 fi
220 ;;
221 esac
222 args+=( "$1" )
223 shift
224 done
225 set -- "${args[@]}"
226 ;;
227 esac
228
229 exec repo ${acmd:-${cmd}} "$@"